﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NAudio.Wave;
using System.ComponentModel.Composition;

namespace FeenPhone.Audio.Codecs
{
    /// <summary>
    /// DSP Group TrueSpeech codec, using ACM
    /// n.b. Windows XP came with a TrueSpeech codec built in
    /// - looks like Windows 7 doesn't
    /// </summary>
    [Export(typeof(INetworkChatCodec))]
    class TrueSpeechChatCodec : AcmChatCodec
    {
        public override CodecID CodecID { get { return CodecID.TrueSpeechChatCodec; } }
        public override bool IsAvailable { get { return base.IsAvailable; } }

        public TrueSpeechChatCodec()
            : base(new WaveFormat(8000, 16, 1), new TrueSpeechWaveFormat())
        {
        }

        public override string Name
        {
            get { return "DSP Group TrueSpeech"; }
        }

    }
}
